import * as React from "react";
import { withRouter } from 'react-router-dom'

class ScrollMemory extends React.Component<any, any> {
  private memoryStore = new Map();

  componentDidMount() {
  }

  componentWillReceiveProps(nextProps) {
  	this.setPosition( this.props.location.pathname, window.scrollY);
  }

  componentDidUpdate( nextProps ) {
  	let targetPathName = nextProps.history.location.pathname,
		targetPosition = this.getPosition(targetPathName);

  	if ( nextProps.history.action == 'POP' ) {
  		this.remove( targetPathName );
  	} else {
  	   targetPosition = 0;
  	}

  	requestAnimationFrame(() => {
        window.scrollTo(0, targetPosition);
    })	
  	
  }

  componentWillUnmount() {
  }

  private getPosition(key): number {
    if (!key) {
      return 0
    }

    return this.memoryStore.get(key) || 0
  }

  private setPosition(key: string, value: number) {
    if (!key) {
      return
    }

    return this.memoryStore.set(key, value)
  }

  private hasKey( key: string ): boolean {
  	return this.memoryStore.has(key);
  }

  private remove( key: string) {
  	if ( this.hasKey( key ) ) {
  		this.memoryStore.delete(key);
  	}
  }

  render() {
     return (
         <div>{this.props.children}</div>
      );
  }
}
export default withRouter(ScrollMemory);